unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, FFPBox, StdCtrls;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    Panel1: TPanel;
    Panel2: TPanel;
    PaintBox1: TPaintBox;
    FlickerFreePaintBox1: TFlickerFreePaintBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure FlickerFreePaintBox1Paint(Sender: TObject; Canvas: TCanvas);
    procedure Timer1Timer(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
procedure DrawImage(Canvas: TCanvas);
const x: Integer = 0;
const y: Integer = 0;
const step: Integer = 10;
begin
  with Canvas do begin
    Brush.Color := clRed;
    Ellipse(x,y, x+200, y+200);
    Brush.Color := clBlue;
    Ellipse(x+5,y+5, x+190, y+190);
    Brush.Color := clLime;
    Ellipse(x+10,y+10, x+180, y+180);
    Brush.Color := clBlack;
    FillRect(Rect(x+50, y+50, x+150, y+150));
  end;
  x := x+ step;
  if x<0 then step := 10;
  if x>400 then step := -10;

end;

procedure TForm1.FlickerFreePaintBox1Paint(Sender: TObject;
  Canvas: TCanvas);
begin
  { do not use FlickerFreePaintBox1.Canvas or
               TFlickerFreePaintBox(Sender).Canvas ! }
   with Canvas do begin
    Brush.Color := clWhite;
    FillRect(Rect(0,0, TFlickerFreePaintBox(Sender).Width,
                             TFlickerFreePaintBox(Sender).Height));
   end;
    DrawImage(Canvas);
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
   with TPaintBox(Sender).Canvas do begin
    Brush.Color := clWhite;
    FillRect(Rect(0,0, TFlickerFreePaintBox(Sender).Width,
                       TFlickerFreePaintBox(Sender).Height));
   end;
   DrawImage(TPaintBox(Sender).Canvas);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  FlickerFreePaintBox1.Refresh;
  PaintBox1.Refresh;
end;

end.
 